# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from squirrel_localizer_msgs/RefScan.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import sensor_msgs.msg
import geometry_msgs.msg
import std_msgs.msg

class RefScan(genpy.Message):
  _md5sum = "ccb88a3ee1ae48e619eec7d79c20b2bd"
  _type = "squirrel_localizer_msgs/RefScan"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """geometry_msgs/PoseWithCovarianceStamped pose
sensor_msgs/LaserScan scan_front_ros
geometry_msgs/TransformStamped transform_front_laser
sensor_msgs/LaserScan scan_rear_ros
geometry_msgs/TransformStamped transform_rear_laser
bool use_second_laser
float64 min_reading
float64 max_reading
string id
================================================================================
MSG: geometry_msgs/PoseWithCovarianceStamped
# This expresses an estimated pose with a reference coordinate frame and timestamp

Header header
PoseWithCovariance pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/PoseWithCovariance
# This represents a pose in free space with uncertainty.

Pose pose

# Row-major representation of the 6x6 covariance matrix
# The orientation parameters use a fixed-axis representation.
# In order, the parameters are:
# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
float64[36] covariance

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: sensor_msgs/LaserScan
# Single scan from a planar laser range-finder
#
# If you have another ranging device with different behavior (e.g. a sonar
# array), please find or create a different message, since applications
# will make fairly laser-specific assumptions about this data

Header header            # timestamp in the header is the acquisition time of 
                         # the first ray in the scan.
                         #
                         # in frame frame_id, angles are measured around 
                         # the positive Z axis (counterclockwise, if Z is up)
                         # with zero angle being forward along the x axis
                         
float32 angle_min        # start angle of the scan [rad]
float32 angle_max        # end angle of the scan [rad]
float32 angle_increment  # angular distance between measurements [rad]

float32 time_increment   # time between measurements [seconds] - if your scanner
                         # is moving, this will be used in interpolating position
                         # of 3d points
float32 scan_time        # time between scans [seconds]

float32 range_min        # minimum range value [m]
float32 range_max        # maximum range value [m]

float32[] ranges         # range data [m] (Note: values < range_min or > range_max should be discarded)
float32[] intensities    # intensity data [device-specific units].  If your
                         # device does not provide intensities, please leave
                         # the array empty.

================================================================================
MSG: geometry_msgs/TransformStamped
# This expresses a transform from coordinate frame header.frame_id
# to the coordinate frame child_frame_id
#
# This message is mostly used by the 
# <a href="http://www.ros.org/wiki/tf">tf</a> package. 
# See its documentation for more information.

Header header
string child_frame_id # the frame id of the child frame
Transform transform

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z"""
  __slots__ = ['pose','scan_front_ros','transform_front_laser','scan_rear_ros','transform_rear_laser','use_second_laser','min_reading','max_reading','id']
  _slot_types = ['geometry_msgs/PoseWithCovarianceStamped','sensor_msgs/LaserScan','geometry_msgs/TransformStamped','sensor_msgs/LaserScan','geometry_msgs/TransformStamped','bool','float64','float64','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       pose,scan_front_ros,transform_front_laser,scan_rear_ros,transform_rear_laser,use_second_laser,min_reading,max_reading,id

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RefScan, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.pose is None:
        self.pose = geometry_msgs.msg.PoseWithCovarianceStamped()
      if self.scan_front_ros is None:
        self.scan_front_ros = sensor_msgs.msg.LaserScan()
      if self.transform_front_laser is None:
        self.transform_front_laser = geometry_msgs.msg.TransformStamped()
      if self.scan_rear_ros is None:
        self.scan_rear_ros = sensor_msgs.msg.LaserScan()
      if self.transform_rear_laser is None:
        self.transform_rear_laser = geometry_msgs.msg.TransformStamped()
      if self.use_second_laser is None:
        self.use_second_laser = False
      if self.min_reading is None:
        self.min_reading = 0.
      if self.max_reading is None:
        self.max_reading = 0.
      if self.id is None:
        self.id = ''
    else:
      self.pose = geometry_msgs.msg.PoseWithCovarianceStamped()
      self.scan_front_ros = sensor_msgs.msg.LaserScan()
      self.transform_front_laser = geometry_msgs.msg.TransformStamped()
      self.scan_rear_ros = sensor_msgs.msg.LaserScan()
      self.transform_rear_laser = geometry_msgs.msg.TransformStamped()
      self.use_second_laser = False
      self.min_reading = 0.
      self.max_reading = 0.
      self.id = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.pose.header.seq, _x.pose.header.stamp.secs, _x.pose.header.stamp.nsecs))
      _x = self.pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d.pack(_x.pose.pose.pose.position.x, _x.pose.pose.pose.position.y, _x.pose.pose.pose.position.z, _x.pose.pose.pose.orientation.x, _x.pose.pose.pose.orientation.y, _x.pose.pose.pose.orientation.z, _x.pose.pose.pose.orientation.w))
      buff.write(_struct_36d.pack(*self.pose.pose.covariance))
      _x = self
      buff.write(_struct_3I.pack(_x.scan_front_ros.header.seq, _x.scan_front_ros.header.stamp.secs, _x.scan_front_ros.header.stamp.nsecs))
      _x = self.scan_front_ros.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7f.pack(_x.scan_front_ros.angle_min, _x.scan_front_ros.angle_max, _x.scan_front_ros.angle_increment, _x.scan_front_ros.time_increment, _x.scan_front_ros.scan_time, _x.scan_front_ros.range_min, _x.scan_front_ros.range_max))
      length = len(self.scan_front_ros.ranges)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.scan_front_ros.ranges))
      length = len(self.scan_front_ros.intensities)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.scan_front_ros.intensities))
      _x = self
      buff.write(_struct_3I.pack(_x.transform_front_laser.header.seq, _x.transform_front_laser.header.stamp.secs, _x.transform_front_laser.header.stamp.nsecs))
      _x = self.transform_front_laser.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.transform_front_laser.child_frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d3I.pack(_x.transform_front_laser.transform.translation.x, _x.transform_front_laser.transform.translation.y, _x.transform_front_laser.transform.translation.z, _x.transform_front_laser.transform.rotation.x, _x.transform_front_laser.transform.rotation.y, _x.transform_front_laser.transform.rotation.z, _x.transform_front_laser.transform.rotation.w, _x.scan_rear_ros.header.seq, _x.scan_rear_ros.header.stamp.secs, _x.scan_rear_ros.header.stamp.nsecs))
      _x = self.scan_rear_ros.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7f.pack(_x.scan_rear_ros.angle_min, _x.scan_rear_ros.angle_max, _x.scan_rear_ros.angle_increment, _x.scan_rear_ros.time_increment, _x.scan_rear_ros.scan_time, _x.scan_rear_ros.range_min, _x.scan_rear_ros.range_max))
      length = len(self.scan_rear_ros.ranges)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.scan_rear_ros.ranges))
      length = len(self.scan_rear_ros.intensities)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.scan_rear_ros.intensities))
      _x = self
      buff.write(_struct_3I.pack(_x.transform_rear_laser.header.seq, _x.transform_rear_laser.header.stamp.secs, _x.transform_rear_laser.header.stamp.nsecs))
      _x = self.transform_rear_laser.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.transform_rear_laser.child_frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7dB2d.pack(_x.transform_rear_laser.transform.translation.x, _x.transform_rear_laser.transform.translation.y, _x.transform_rear_laser.transform.translation.z, _x.transform_rear_laser.transform.rotation.x, _x.transform_rear_laser.transform.rotation.y, _x.transform_rear_laser.transform.rotation.z, _x.transform_rear_laser.transform.rotation.w, _x.use_second_laser, _x.min_reading, _x.max_reading))
      _x = self.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.pose is None:
        self.pose = geometry_msgs.msg.PoseWithCovarianceStamped()
      if self.scan_front_ros is None:
        self.scan_front_ros = sensor_msgs.msg.LaserScan()
      if self.transform_front_laser is None:
        self.transform_front_laser = geometry_msgs.msg.TransformStamped()
      if self.scan_rear_ros is None:
        self.scan_rear_ros = sensor_msgs.msg.LaserScan()
      if self.transform_rear_laser is None:
        self.transform_rear_laser = geometry_msgs.msg.TransformStamped()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.pose.header.seq, _x.pose.header.stamp.secs, _x.pose.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.pose.pose.pose.position.x, _x.pose.pose.pose.position.y, _x.pose.pose.pose.position.z, _x.pose.pose.pose.orientation.x, _x.pose.pose.pose.orientation.y, _x.pose.pose.pose.orientation.z, _x.pose.pose.pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      start = end
      end += 288
      self.pose.pose.covariance = _struct_36d.unpack(str[start:end])
      _x = self
      start = end
      end += 12
      (_x.scan_front_ros.header.seq, _x.scan_front_ros.header.stamp.secs, _x.scan_front_ros.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.scan_front_ros.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.scan_front_ros.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.scan_front_ros.angle_min, _x.scan_front_ros.angle_max, _x.scan_front_ros.angle_increment, _x.scan_front_ros.time_increment, _x.scan_front_ros.scan_time, _x.scan_front_ros.range_min, _x.scan_front_ros.range_max,) = _struct_7f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.scan_front_ros.ranges = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.scan_front_ros.intensities = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 12
      (_x.transform_front_laser.header.seq, _x.transform_front_laser.header.stamp.secs, _x.transform_front_laser.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.transform_front_laser.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.transform_front_laser.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.transform_front_laser.child_frame_id = str[start:end].decode('utf-8')
      else:
        self.transform_front_laser.child_frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.transform_front_laser.transform.translation.x, _x.transform_front_laser.transform.translation.y, _x.transform_front_laser.transform.translation.z, _x.transform_front_laser.transform.rotation.x, _x.transform_front_laser.transform.rotation.y, _x.transform_front_laser.transform.rotation.z, _x.transform_front_laser.transform.rotation.w, _x.scan_rear_ros.header.seq, _x.scan_rear_ros.header.stamp.secs, _x.scan_rear_ros.header.stamp.nsecs,) = _struct_7d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.scan_rear_ros.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.scan_rear_ros.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.scan_rear_ros.angle_min, _x.scan_rear_ros.angle_max, _x.scan_rear_ros.angle_increment, _x.scan_rear_ros.time_increment, _x.scan_rear_ros.scan_time, _x.scan_rear_ros.range_min, _x.scan_rear_ros.range_max,) = _struct_7f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.scan_rear_ros.ranges = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.scan_rear_ros.intensities = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 12
      (_x.transform_rear_laser.header.seq, _x.transform_rear_laser.header.stamp.secs, _x.transform_rear_laser.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.transform_rear_laser.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.transform_rear_laser.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.transform_rear_laser.child_frame_id = str[start:end].decode('utf-8')
      else:
        self.transform_rear_laser.child_frame_id = str[start:end]
      _x = self
      start = end
      end += 73
      (_x.transform_rear_laser.transform.translation.x, _x.transform_rear_laser.transform.translation.y, _x.transform_rear_laser.transform.translation.z, _x.transform_rear_laser.transform.rotation.x, _x.transform_rear_laser.transform.rotation.y, _x.transform_rear_laser.transform.rotation.z, _x.transform_rear_laser.transform.rotation.w, _x.use_second_laser, _x.min_reading, _x.max_reading,) = _struct_7dB2d.unpack(str[start:end])
      self.use_second_laser = bool(self.use_second_laser)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.id = str[start:end].decode('utf-8')
      else:
        self.id = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.pose.header.seq, _x.pose.header.stamp.secs, _x.pose.header.stamp.nsecs))
      _x = self.pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d.pack(_x.pose.pose.pose.position.x, _x.pose.pose.pose.position.y, _x.pose.pose.pose.position.z, _x.pose.pose.pose.orientation.x, _x.pose.pose.pose.orientation.y, _x.pose.pose.pose.orientation.z, _x.pose.pose.pose.orientation.w))
      buff.write(self.pose.pose.covariance.tostring())
      _x = self
      buff.write(_struct_3I.pack(_x.scan_front_ros.header.seq, _x.scan_front_ros.header.stamp.secs, _x.scan_front_ros.header.stamp.nsecs))
      _x = self.scan_front_ros.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7f.pack(_x.scan_front_ros.angle_min, _x.scan_front_ros.angle_max, _x.scan_front_ros.angle_increment, _x.scan_front_ros.time_increment, _x.scan_front_ros.scan_time, _x.scan_front_ros.range_min, _x.scan_front_ros.range_max))
      length = len(self.scan_front_ros.ranges)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.scan_front_ros.ranges.tostring())
      length = len(self.scan_front_ros.intensities)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.scan_front_ros.intensities.tostring())
      _x = self
      buff.write(_struct_3I.pack(_x.transform_front_laser.header.seq, _x.transform_front_laser.header.stamp.secs, _x.transform_front_laser.header.stamp.nsecs))
      _x = self.transform_front_laser.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.transform_front_laser.child_frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d3I.pack(_x.transform_front_laser.transform.translation.x, _x.transform_front_laser.transform.translation.y, _x.transform_front_laser.transform.translation.z, _x.transform_front_laser.transform.rotation.x, _x.transform_front_laser.transform.rotation.y, _x.transform_front_laser.transform.rotation.z, _x.transform_front_laser.transform.rotation.w, _x.scan_rear_ros.header.seq, _x.scan_rear_ros.header.stamp.secs, _x.scan_rear_ros.header.stamp.nsecs))
      _x = self.scan_rear_ros.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7f.pack(_x.scan_rear_ros.angle_min, _x.scan_rear_ros.angle_max, _x.scan_rear_ros.angle_increment, _x.scan_rear_ros.time_increment, _x.scan_rear_ros.scan_time, _x.scan_rear_ros.range_min, _x.scan_rear_ros.range_max))
      length = len(self.scan_rear_ros.ranges)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.scan_rear_ros.ranges.tostring())
      length = len(self.scan_rear_ros.intensities)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.scan_rear_ros.intensities.tostring())
      _x = self
      buff.write(_struct_3I.pack(_x.transform_rear_laser.header.seq, _x.transform_rear_laser.header.stamp.secs, _x.transform_rear_laser.header.stamp.nsecs))
      _x = self.transform_rear_laser.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.transform_rear_laser.child_frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7dB2d.pack(_x.transform_rear_laser.transform.translation.x, _x.transform_rear_laser.transform.translation.y, _x.transform_rear_laser.transform.translation.z, _x.transform_rear_laser.transform.rotation.x, _x.transform_rear_laser.transform.rotation.y, _x.transform_rear_laser.transform.rotation.z, _x.transform_rear_laser.transform.rotation.w, _x.use_second_laser, _x.min_reading, _x.max_reading))
      _x = self.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.pose is None:
        self.pose = geometry_msgs.msg.PoseWithCovarianceStamped()
      if self.scan_front_ros is None:
        self.scan_front_ros = sensor_msgs.msg.LaserScan()
      if self.transform_front_laser is None:
        self.transform_front_laser = geometry_msgs.msg.TransformStamped()
      if self.scan_rear_ros is None:
        self.scan_rear_ros = sensor_msgs.msg.LaserScan()
      if self.transform_rear_laser is None:
        self.transform_rear_laser = geometry_msgs.msg.TransformStamped()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.pose.header.seq, _x.pose.header.stamp.secs, _x.pose.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.pose.pose.pose.position.x, _x.pose.pose.pose.position.y, _x.pose.pose.pose.position.z, _x.pose.pose.pose.orientation.x, _x.pose.pose.pose.orientation.y, _x.pose.pose.pose.orientation.z, _x.pose.pose.pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      start = end
      end += 288
      self.pose.pose.covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=36)
      _x = self
      start = end
      end += 12
      (_x.scan_front_ros.header.seq, _x.scan_front_ros.header.stamp.secs, _x.scan_front_ros.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.scan_front_ros.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.scan_front_ros.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.scan_front_ros.angle_min, _x.scan_front_ros.angle_max, _x.scan_front_ros.angle_increment, _x.scan_front_ros.time_increment, _x.scan_front_ros.scan_time, _x.scan_front_ros.range_min, _x.scan_front_ros.range_max,) = _struct_7f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.scan_front_ros.ranges = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.scan_front_ros.intensities = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      _x = self
      start = end
      end += 12
      (_x.transform_front_laser.header.seq, _x.transform_front_laser.header.stamp.secs, _x.transform_front_laser.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.transform_front_laser.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.transform_front_laser.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.transform_front_laser.child_frame_id = str[start:end].decode('utf-8')
      else:
        self.transform_front_laser.child_frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.transform_front_laser.transform.translation.x, _x.transform_front_laser.transform.translation.y, _x.transform_front_laser.transform.translation.z, _x.transform_front_laser.transform.rotation.x, _x.transform_front_laser.transform.rotation.y, _x.transform_front_laser.transform.rotation.z, _x.transform_front_laser.transform.rotation.w, _x.scan_rear_ros.header.seq, _x.scan_rear_ros.header.stamp.secs, _x.scan_rear_ros.header.stamp.nsecs,) = _struct_7d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.scan_rear_ros.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.scan_rear_ros.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.scan_rear_ros.angle_min, _x.scan_rear_ros.angle_max, _x.scan_rear_ros.angle_increment, _x.scan_rear_ros.time_increment, _x.scan_rear_ros.scan_time, _x.scan_rear_ros.range_min, _x.scan_rear_ros.range_max,) = _struct_7f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.scan_rear_ros.ranges = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.scan_rear_ros.intensities = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      _x = self
      start = end
      end += 12
      (_x.transform_rear_laser.header.seq, _x.transform_rear_laser.header.stamp.secs, _x.transform_rear_laser.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.transform_rear_laser.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.transform_rear_laser.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.transform_rear_laser.child_frame_id = str[start:end].decode('utf-8')
      else:
        self.transform_rear_laser.child_frame_id = str[start:end]
      _x = self
      start = end
      end += 73
      (_x.transform_rear_laser.transform.translation.x, _x.transform_rear_laser.transform.translation.y, _x.transform_rear_laser.transform.translation.z, _x.transform_rear_laser.transform.rotation.x, _x.transform_rear_laser.transform.rotation.y, _x.transform_rear_laser.transform.rotation.z, _x.transform_rear_laser.transform.rotation.w, _x.use_second_laser, _x.min_reading, _x.max_reading,) = _struct_7dB2d.unpack(str[start:end])
      self.use_second_laser = bool(self.use_second_laser)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.id = str[start:end].decode('utf-8')
      else:
        self.id = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_7f = struct.Struct("<7f")
_struct_7d = struct.Struct("<7d")
_struct_36d = struct.Struct("<36d")
_struct_7dB2d = struct.Struct("<7dB2d")
_struct_3I = struct.Struct("<3I")
_struct_7d3I = struct.Struct("<7d3I")
